//------------------------------------------------------
#include <Servo.h>   //dołączenie biblioteki do obsługi serw
Servo servox;       //tworzymy obiekt kontrolujacy serwo 1
Servo servoy;       //tworzymy obiekt kontrolujacy serwo 2

//------------------------------------------------------
int servox_pin = 8;  //sterowanie serwa 1 na wyprowadzeniu 8
int servoy_pin = 9;  //sterowanie serwa 2 na wyprowadzeniu 9
int joyx_pin = 0;    //sygnał z osi x joysticka na wyprowadzeniu 0
int joyy_pin = 1;    //sygnał z osi y joysticka na wyprowadzeniu 1

//------------------------------------------------------
int analog_x;        //wychylenie osi x
int analog_y;        //wychylenie osi y
int degree_x;        //położenie serwa osi x
int degree_y;        //położenie serwa osi y


//----------------------------------------------------------
void setup()
{
  servox.attach(servox_pin);  //serwo x przypisane do wyprowadzenia 8
  servoy.attach(servoy_pin);  //serwo y przypisane do wyprowadzenia 9

  degree_x = 90;    //położenie początkowe serva osi x  
  degree_y = 90;    //położenie początkowe serva osi y  
}

//----------------------------------------------------------
void loop()
{
  int temp;  //zmienna pomocnicza

  //odczyt położenia joystika,
  //odczyt wartosci analogowych
  analog_x = analogRead(joyx_pin);     
  analog_y = analogRead(joyy_pin);

  //przeskalowanie wartosci analogowej
  //na wartość kąta odchylenia serwomechanizmów
  //oraz odwrócenie ruchu - teraz podąża za joystickiem
  temp = map(analog_x, 0, 1023, 180, 0);  

  //powolne dochodzenie do zadanej wartości kąta x
  //o 1 jeden stopień przy każdym przejściu pętli 
  if (degree_x < temp) degree_x++;
  if (degree_x > temp) degree_x--;
    
  //przeskalowanie wartosci analogowej
  //na wartość kąta odchylenia serwomechanizmów
  temp = map(analog_y, 0, 1023, 0, 180);  

  //powolne dochodzenie do zadanej wartości kata y
  //o 1 jeden stopień przy każdym przejściu pętli 
  if (degree_y < temp) degree_y++;
  if (degree_y > temp) degree_y--;

  //ustawienie serwomechanizmów
  servox.write(degree_x);
  servoy.write(degree_y);

  //przerwa, ustala szybkość ruchu serw
  delay(30);
}
